#include <stdlib.h>
#include <time.h>

#include "htpl_driver.h"

static time_t start_time;

static void start(FILE* out) {
  start_time = time(0);
  fprintf(out, "//The file has been generated by %s at %s", getprogname(), ctime(&start_time));
  fprintf(out, "//DO NOT EDIT!\n");
  fprintf(out, "#include <httpd.h>\n");
  fprintf(out, "#include <http_protocol.h>\n");
}

static void finish_header(FILE* hout, FILE* out) {
  //out header
  if(hout) {
    fprintf(hout, "//The file has been generated by %s at %s", getprogname(), ctime(&start_time));
    fprintf(hout, "//DO NOT EDIT!\n");
    fprintf(hout, "void %s%s(request_rec* r",funcprefix, funcname);
    if(tplargs)
      fprintf(hout, ", %s", tplargs);
    fprintf(hout, ");\n");
  }

  fprintf(out, "void %s%s(request_rec* r",funcprefix, funcname);
  if(tplargs)
    fprintf(out, ", %s", tplargs);
  fprintf(out, ") {\n");
}

static void out_static_block(FILE* out, const char* text, int textlen) {
  fprintf(out, "\tap_rwrite(\"");
  int i;
  const char* cp = text;
  for(i=0; i<textlen; i++, cp++) {
    char c=*cp;
    if(isprint(c) && c!= '"' && c!='\\')
      putc(c, out);
    else
      fprintf(out, "\\%03o", c);
  }
  fprintf(out, "\",%d, r);\n", textlen);
}

static void out_dynamic_block(FILE* out, const char* text, int textlen) {
  fprintf(out, "\tap_rvputs(r, %*s, 0);\n", textlen, text);
}

static void out_printf_block(FILE* out, const char* text, int textlen) {
  fprintf(out, "\tap_rprintf(r, %*s);\n", textlen, text);
}

struct htpl_driver apache_driver = {
  &start,
  &finish_header,
  &out_static_block,
  &out_dynamic_block,
  &out_printf_block
};
